#include <iostream.h>
#include <fstream.h>
#include <string.h>

#define BYTES_PER_LINE 32

int main( int argc, char *argv[] )
{
	int i,j;

	int line, subline, column, bit;
	unsigned char ch,binval;

	char destname[80];

	unsigned char linearr[40][8];

	cout << "imgcnv ::: raw bitmap -> c64 hi-res converter :::" << endl << endl;

	if( argc != 2 )
	{
		cout << "usage: imgcnv <raw image file>" << endl;
		cout << "input file: 320x200, 1 pixel per byte, 0 = pixel off, !0 = pixel on" << endl;
		cout << "output file: 8 pixels per byte, c64 hi-res-mode byte order, extension .h64" << endl;
		return(1);
	}

	ifstream imagefile( argv[1], ios::binary );

	if( !imagefile.is_open() )
	{
		cout << "(!) could not open " << argv[1] << endl;
		return(1);
	}

	// generate output filename: name.h64
	strcpy( destname, argv[1] );
	strtok( destname, "." );
	strcat( destname, ".h64" );

	ofstream dest( destname, ios::binary );
	
	if( !dest.is_open() )
	{
		cout << "(!) could not open output file " << destname << endl;
		return(1);
	}

	cout << "converting " << argv[1] << " to " << destname << endl;

	for( line=0; line<25; line++ )
	{
		for( subline=0; subline<8; subline++ )
		{
			for( column=0; column<40; column++ )
			{
				binval = 0;
				for( bit=256; bit!=1; bit/=2 )
				{
					imagefile.get(ch);
					if( !ch )
					{
						binval += bit/2;
					}
				}
				linearr[column][subline] = binval;
			}
		}

		for( column=0; column<40; column++ )
		{
			for( subline=0; subline<8; subline++ )
			{
				dest << linearr[column][subline];			

			} // subline

		} // column

	} // line

	return( 0 );

} // main()